$white: #ffffff;
$sea-green: #a2ccb6;
$sandy-yellow: #fceeb5;
$peach: #ee786e;
$menu-size: 100px;
$menu-animate-time: 0.3s;
$menu-icon-size-1: 50px;
$menu-icon-size-2: 10px;
$menu-icon-size-1-half: 50px / 2;
$menu-icon-animate-time: 1.3s;
$menu-icon-animate-time-back: 0.3s;
$menu-icon-keyframes-1: menu-icon-animate-1;
$menu-icon-keyframes-2: menu-icon-animate-2;
$menu-icon-keyframes-3: menu-icon-animate-3;
$menu-icon-keyframes-4: menu-icon-animate-4;
$menu-list-box-width: 250px;
$menu-list-box-height: 70px;
$menu-list-box-margin: 10px;
$menu-list-box-animate-time: 0.5s;
$menu-list-box-icon-size: 40px;
$menu-list-box-icon-animate-time: 0.3s;

@mixin menu-icon($width, $height) {
	background-color: $sandy-yellow;
	width: $width;
	height: $height;
	position: absolute;
	top: calc(50% - #{$height / 2});
	left: calc(50% - #{$width / 2});
	@if $width > $height {
		border-radius: 10% / 50%;
	}
	@else {
		border-radius: 50% / 10%;
	}
}

@mixin menu-icon-animation($margin-top, $margin-left, $div2-top, $div2-left, $deg-1, $deg-2, $keyframes) {
	@keyframes #{$keyframes} {
		0%        { margin-top: 0; margin-left: 0; opacity: 1; transform: rotate($deg-1); }
		49.99999% { margin-top: $margin-top; margin-left: $margin-left; opacity: 0; transform: rotate($deg-1); }
		50%       { margin-top: ($div2-top / 2); margin-left: ($div2-left / 2); opacity: 0; transform: rotate($deg-2); }
		100%      { margin-top: 0; margin-right: 0; opacity: 1; transform: rotate($deg-2); }
	}
}

html, body {
	width: 100%;
	height: 100%;
	margin: 0;
	padding: 0;
}

body {
	background-color: $sea-green;
	display: flex;
	align-items: center;
	justify-content: center;
	flex-wrap: wrap;
}

.menu {
	background-color: $peach;
	width: $menu-size;
	height: $menu-size;
	position: relative;
	cursor: pointer;
	border-radius: 50%;
	.menu-icon-1 {
		@include menu-icon($menu-icon-size-1, $menu-icon-size-2);
	}
	.menu-icon-2 {
		@include menu-icon($menu-icon-size-2, $menu-icon-size-1);
	}
	.menu-list-box {
		background-color: $sandy-yellow;
		width: $menu-icon-size-2;
		height: 0;
		position: absolute;
		bottom: ($menu-size + $menu-list-box-margin);
		left: calc(50% - #{$menu-icon-size-2 / 2});
		display: flex;
		justify-content: space-around;
		align-items: center;
		border-radius: 0;
		transition:
			height $menu-list-box-animate-time ($menu-animate-time + $menu-list-box-animate-time),
			width $menu-list-box-animate-time $menu-animate-time,
			left $menu-list-box-animate-time $menu-animate-time,
			border-radius $menu-list-box-animate-time $menu-animate-time;
		> .fa {
			color: transparent;
			font-size: $menu-list-box-icon-size;
			opacity: 0;
			transition:
				color $menu-list-box-icon-animate-time,
				border-radius $menu-list-box-icon-animate-time,
				transform $menu-list-box-icon-animate-time,
				opacity $menu-list-box-icon-animate-time ease-in $menu-list-box-icon-animate-time + $menu-animate-time;
		}
	}
	&.active {
		animation: $menu-animate-time menu-to-active linear;
		.menu-icon-1 {
			animation: $menu-icon-animate-time $menu-icon-keyframes-1 ease-out forwards;
		}
		.menu-icon-2 {
			animation: $menu-icon-animate-time $menu-icon-keyframes-2 ease-out forwards;
		}
		.menu-list-box {
			width: $menu-list-box-width;
			height: $menu-list-box-height;
			left: calc(50% - #{$menu-list-box-width / 2});
			border-radius: #{$menu-list-box-height * (10 / 100)};
			transition:
				height $menu-list-box-animate-time $menu-animate-time,
				width $menu-list-box-animate-time ($menu-animate-time + $menu-list-box-animate-time),
				left $menu-list-box-animate-time ($menu-animate-time + $menu-list-box-animate-time),
				border-radius $menu-list-box-animate-time ($menu-animate-time + $menu-list-box-animate-time);
			> .fa {
				color: $peach;
				opacity: 1;
				&:hover, &:focus, &:active {
					background-color: $sandy-yellow;
					color: $sea-green;
					border-radius: 40% / 15%;
					transform: scale(1.4);
				}
			}
		}
	}
	&.clicked {
		animation: $menu-animate-time menu-to-inactive linear;
		.menu-icon-1 {
			animation: $menu-icon-animate-time $menu-icon-keyframes-3 ease-out forwards;
		}
		.menu-icon-2 {
			animation: $menu-icon-animate-time $menu-icon-keyframes-4 ease-out forwards;
		}
	}
}

@keyframes menu-to-active {
	0%   { transform: scale(1); }
	50%  { transform: scale(1.2); }
	100% { transform: scale(1); }
}

@keyframes menu-to-inactive {
	0%   { transform: scale(1); }
	50%  { transform: scale(0.8); }
	100% { transform: scale(1); }
}

@include menu-icon-animation(0, -$menu-icon-size-1, -$menu-icon-size-1-half, -$menu-icon-size-1-half, 0deg, 45deg, $menu-icon-keyframes-1);
@include menu-icon-animation(-$menu-icon-size-1, 0, -$menu-icon-size-1-half, $menu-icon-size-1-half, 0deg, 45deg, $menu-icon-keyframes-2);
@include menu-icon-animation($menu-icon-size-1-half, $menu-icon-size-1-half, 0, $menu-icon-size-1, 45deg, 0deg, $menu-icon-keyframes-3);
@include menu-icon-animation($menu-icon-size-1-half, -$menu-icon-size-1-half, $menu-icon-size-1, 0, 45deg, 0deg, $menu-icon-keyframes-4);

@media (max-width: $menu-size) {
	.menu {
		width: 100vw;
		height: 100vw;
		.menu-icon-1 {
			width: 50vw;
			height: 10vw;
			top: calc(50% - 5vw);
			left: calc(50% - 25vw);
		}
		.menu-icon-2 {
			width: 10vw;
			height: 50vw;
			top: calc(50% - 25vw);
			left: calc(50% - 5vw);
		}
		.menu-list-box {
			bottom: calc(100vw + #{$menu-list-box-margin});
		}
	}
}
